/*
 * Created on 2004/08/21
 *
 * CodeIndenter.
 * Ando Computer Behavior R&D.
 */
package jp.sourceforge.projects.ee2e.cindenter;


import javax.swing.table.*;

/**
 * @author ando@park.ruru.ne.jp
 * 
 * Folder selection
 */
class CIIfdefTableModel extends AbstractTableModel {
    public static final String TARGET_DEFINE = "tablemodem.targetdefine";
    public static final String ACTION = "tablemodem.action";
    public static final String NO_DATA = "tablemodem.nodata";
    public static final String IF_DEF = "tablemodem.ifdef";
    public static final String IF_N_DEF = "tablemodem.ifndef";
    public static final String NO_ACTION = "tablemodem.noaction";
    public CIIfdefTableModel() {
    }
     public int getRowCount() {
         CIIfdefData [] list = CIPlugin.getDefault().getProfile().getIfdefList();
         if (list == null) {
             return 0;
         }
         return list.length;
     }
     public int getColumnCount() {
         return 2;
     }
     public String getColumnName( int column ) {
         if (column == 0) {
             return CIPlugin.getDefault().getString(TARGET_DEFINE);
         } else {
             return CIPlugin.getDefault().getString(ACTION);
         }
     }
     public Object getValueAt(int row, int column) {
         CIIfdefData [] list = CIPlugin.getDefault().getProfile().getIfdefList();
         if (list == null) {
             return CIPlugin.getDefault().getString(NO_DATA);
         }
         CIIfdefData data = list[row];
         if (column == 0) {
             return data.getKey();
         } if (column == 1) {
             if( data.isIfdefExecute() ) {
                 if (data.ifdefOrIfndef()) {
                     return CIPlugin.getDefault().getString(IF_DEF);
                 } else {
                     return CIPlugin.getDefault().getString(IF_N_DEF);
                 }
             } else {
                 return CIPlugin.getDefault().getString(NO_ACTION);
             }
         }
         return CIPlugin.getDefault().getString(NO_DATA);
     }
}
